// -------------------------------------------------------------
// HSVϊ
// 
// Copyright (c) 2003 IMAGIRE Takashi. All rights reserved.
// -------------------------------------------------------------

// -------------------------------------------------------------
// O[oϐ
// -------------------------------------------------------------
float4x4 mWVP;
float4 LightPos;
float fShift;

// -------------------------------------------------------------
// eNX`
// -------------------------------------------------------------
// ͗l̃eNX`
texture DecaleTex;
sampler DecaleSamp = sampler_state
{
    Texture = <DecaleTex>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};
// -------------------------------------------------------------
// AvP[V璸_VF[_ɓnf[^
// -------------------------------------------------------------
struct VS_INPUT
{
    float4 Pos          : POSITION;
    float3 Normal       : NORMAL0;
    float2 Tex			: TEXCOORD0;	// fJ[eNX`W
};
// -------------------------------------------------------------
// _VF[_sNZVF[_ɓnf[^
// -------------------------------------------------------------
struct VS_OUTPUT
{
    float4 Pos          : POSITION;
    float2 Tex			: TEXCOORD0;	// fJ[eNX`W
    float  LN		    : TEXCOORD1;	// dot(L,N)
};

// -------------------------------------------------------------
// _VF[_vO
// -------------------------------------------------------------
VS_OUTPUT VS(VS_INPUT In)
{   
	VS_OUTPUT Out = (VS_OUTPUT)0;			 // o̓f[^
	
	// ʒuW
	Out.Pos = mul( In.Pos, mWVP );
	
	// \ʍWn̊xNg߂
	float3 N = In.Normal;					// @xNg
	
	// xNgeNX`W֕ϊ
	float3 L = normalize(LightPos-In.Pos.xyz);// CgxNg
	Out.LN = dot(N,L);
	
	// fJ[̃eNX`W
	Out.Tex = In.Tex;

    return Out;
}
// -------------------------------------------------------------
// sNZVF[_vO
// -------------------------------------------------------------
float4 PS(VS_OUTPUT In) : COLOR
{   
//    const float NO_HUE = -1;
    float4 ret = (float4)0;
    float4 decale = tex2D( DecaleSamp, In.Tex );	  // fJ[
    float3 rgb = decale.xyz;    // ɂȂF
    float3 hsv;
    
    // RGB 2 HSV
    float max = max(rgb.r, max(rgb.g, rgb.b));
    float min = min(rgb.r, min(rgb.g, rgb.b));
    float delta = max - min;

	hsv.z = max; // v
	if (max != 0.0){
	    hsv.y = delta / max;//s
	}else{
	    hsv.y = 0.0;//s
    }
	
//	if (hsv.y == 0.0) {
//		hsv.x = NO_HUE; // h
//	} else {
      if ( rgb.r == max ){
          hsv.x =     (rgb.g - rgb.b) / delta;// h
      }else if (rgb.g == max){
          hsv.x = 2 + (rgb.b - rgb.r) / delta;// h
      }else{
          hsv.x = 4 + (rgb.r - rgb.g) / delta;// h
      }
      hsv.x /= 6.0;
      if (hsv.x < 0) hsv.x += 1.0;
//  }
	
	hsv.x += fShift;								// F␳
    if (1.0 <= hsv.x) hsv.x -= 1.0;
	
    // HSV 2 RGB
    if ( hsv.y == 0 ){ /* Grayscale */
        ret.r = ret.g = ret.b = hsv.z;// v
    } else {
        if (1.0 <= hsv.x) hsv.x -= 1.0;
        hsv.x *= 6.0;
        float i = floor (hsv.x);
        float f = hsv.x - i;
        float aa = hsv.z * (1 - hsv.y);
        float bb = hsv.z * (1 - (hsv.y * f));
        float cc = hsv.z * (1 - (hsv.y * (1 - f)));
        if( i < 1 ){
	        ret.r = hsv.z; ret.g = cc;    ret.b = aa;
        }else if( i < 2 ){
	    	ret.r = bb;    ret.g = hsv.z; ret.b = aa;
        }else if( i < 3 ){
    		ret.r = aa;    ret.g = hsv.z; ret.b = cc;
        }else if( i < 4 ){
    		ret.r = aa;    ret.g = bb;    ret.b = hsv.z;
        }else if( i < 5 ){
    		ret.r = cc;    ret.g = aa;    ret.b = hsv.z;
        }else{
    		ret.r = hsv.z; ret.g = aa;    ret.b = bb;
        }
    }
	
	return (0.5f*In.LN + 0.5f) * ret;
}
// -------------------------------------------------------------
// eNjbN
// -------------------------------------------------------------
technique TShader
{
    pass P0
    {
        VertexShader = compile vs_1_1 VS();
        PixelShader  = compile ps_2_0 PS();
    }
}

